2021-12-08 07:12:21

by Po-Hsu Lin

[permalink] [raw]
Subject: [PATCH] selftests: icmp_redirect: pass xfail=0 to log_test() for non-xfail cases

If any sub-test in this icmp_redirect.sh is failing but not expected
to fail. The script will complain:
./icmp_redirect.sh: line 72: [: 1: unary operator expected

This is because when the sub-test is not expected to fail, we won't
pass any value for the xfail local variable in log_test() and thus
it's empty. Fix this by passing 0 as the 4th variable to log_test()
for non-xfail cases.

Signed-off-by: Po-Hsu Lin <[email protected]>
---
tools/testing/selftests/net/icmp_redirect.sh | 2 +-
1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/tools/testing/selftests/net/icmp_redirect.sh b/tools/testing/selftests/net/icmp_redirect.sh
index ecbf57f..7b9d6e3 100755
--- a/tools/testing/selftests/net/icmp_redirect.sh
+++ b/tools/testing/selftests/net/icmp_redirect.sh
@@ -311,7 +311,7 @@ check_exception()
ip -netns h1 ro get ${H1_VRF_ARG} ${H2_N2_IP} | \
grep -E -v 'mtu|redirected' | grep -q "cache"
fi
- log_test $? 0 "IPv4: ${desc}"
+ log_test $? 0 "IPv4: ${desc}" 0

# No PMTU info for test "redirect" and "mtu exception plus redirect"
if [ "$with_redirect" = "yes" ] && [ "$desc" != "redirect exception plus mtu" ]; then
--
2.7.4



2021-12-10 02:46:26

by Jakub Kicinski

[permalink] [raw]
Subject: Re: [PATCH] selftests: icmp_redirect: pass xfail=0 to log_test() for non-xfail cases

On Wed, 8 Dec 2021 15:11:51 +0800 Po-Hsu Lin wrote:
> If any sub-test in this icmp_redirect.sh is failing but not expected
> to fail. The script will complain:
> ./icmp_redirect.sh: line 72: [: 1: unary operator expected
>
> This is because when the sub-test is not expected to fail, we won't
> pass any value for the xfail local variable in log_test() and thus
> it's empty. Fix this by passing 0 as the 4th variable to log_test()
> for non-xfail cases.
>
> Signed-off-by: Po-Hsu Lin <[email protected]>

Thanks, could you please add a fixes tag (even if the breakage is only
present in linux-next) and CC David Ahern on v2?

2021-12-10 07:16:25

by Po-Hsu Lin

[permalink] [raw]
Subject: Re: [PATCH] selftests: icmp_redirect: pass xfail=0 to log_test() for non-xfail cases

On Fri, Dec 10, 2021 at 10:46 AM Jakub Kicinski <[email protected]> wrote:
>
> On Wed, 8 Dec 2021 15:11:51 +0800 Po-Hsu Lin wrote:
> > If any sub-test in this icmp_redirect.sh is failing but not expected
> > to fail. The script will complain:
> > ./icmp_redirect.sh: line 72: [: 1: unary operator expected
> >
> > This is because when the sub-test is not expected to fail, we won't
> > pass any value for the xfail local variable in log_test() and thus
> > it's empty. Fix this by passing 0 as the 4th variable to log_test()
> > for non-xfail cases.
> >
> > Signed-off-by: Po-Hsu Lin <[email protected]>
>
> Thanks, could you please add a fixes tag (even if the breakage is only
> present in linux-next) and CC David Ahern on v2?

Sure thing,
I will add fixes tag for this commit:
0a36a75c selftests: icmp_redirect: support expected failures

thanks for the feedback.